searchNodes=[{"ref":"Xcribe.html","title":"Xcribe","type":"module","doc":"Xcribe is a library for API documentation. It generates docs from your test specs. Xcribe use Plug.Conn struct to fetch information about requests and use them to document your API. You must give requests examples (from your tests ) to Xcribe be able to document your routes. Each connection sent to documenting in your tests is parsed. Is expected that connection has been passed through the app Endpoint as a finished request. The parser will extract all needed info from Conn and uses app Router for additional information about the request. The attribute description may be given at document macro call with the option :as: test &quot;test name&quot;, %{conn: conn} do ... document(conn, as: &quot;description here&quot;) ... end If no description is given the current test description will be used. API information You must provide your API information by creatint a mudule that use Xcribe.Information macros. The required info are: name - a name for your API. description - a description about your API. host - your API host url This information is set by Xcribe macros inside the block xcribe_info. eg: defmodule YourModuleInformation do use Xcribe.Information xcribe_info do name &quot;Your awesome API&quot; description &quot;The best API in the world&quot; host &quot;http://your-api.us&quot; end end See Xcribe.Information for more details about custom information. JSON Xcribe uses the same json library configured for Phoenix to handle json content. you can configure xcribe to use your preferred library. Poison and Jason are the most popular json libraries common used in Elixir and Xcribe works fine with both. Configuration You must configure at least the information_source and format for basic use. eg config :xcribe, information_source: YourApp.YouModuleInformation, format: :swagger Available configurations: :information_source - Module that implements Xcribe.Information with API information. It&#39;s required. :output - The name of file output with generated configuration. Default value changes by the format, &#39;api_blueprint.apib&#39; for Blueprint and &#39;app_doc.json&#39; for swagger. :format - Format to generate documentation, allowed :api_blueprint and :swagger. Default :api_blueprint. :env_var - Environment variable name for active Xcribe documentation generator. Default is XCRIBE_ENV. :json_library - The library to be used for json decode/encode (Jason and Poison are supported). The default is the same as Phoenix configuration. :serve - Enable Xcribe serve mode. Default false. See more Serving doc"},{"ref":"Xcribe.Document.html","title":"Xcribe.Document","type":"module","doc":"Exposes document/2 macro to be used in test specs."},{"ref":"Xcribe.Document.html#document/2","title":"Xcribe.Document.document/2","type":"macro","doc":"Document a request by a given Plug.Conn. Each connection sent to documenting in your tests is parsed. Is expected that connection has been passed through the app Endpoint as a finished request. The parser will extract all needed info from Conn and uses app Router for additional information about the request. The attribute description may be given at document macro call with the option :as: test &quot;test name&quot;, %{conn: conn} do ... document(conn, as: &quot;description here&quot;) ... end If no description is given the current test description will be used."},{"ref":"Xcribe.Formatter.html","title":"Xcribe.Formatter","type":"module","doc":"An implementation of ExUnit Formatter. This module is a GenServer that receives ExUnits events from your test suite. It handles the suite_finished event and then generates the documentation from the collected requests. You must add Xcribe.Formatter in the list of formatters in your test_helper.exs. ExUnit.start(formatters: [ExUnit.CLIFormatter, Xcribe.Formatter]) You must keep ExUnit.CLIFormatter in the list as well. The document will be generated if the pre-configured env var has a truthy value. Other wise the Formatter will ignore the finished event. All request documented with macro document/2 (See Xcribe) will be parsed by Xcribe. When the test suite finish Xcribe.Formatter will check if all colleted requests are valid. If some invalid request is found, an error output will appear and the documentation will not be generated."},{"ref":"Xcribe.Formatter.html#child_spec/1","title":"Xcribe.Formatter.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Xcribe.Information.html","title":"Xcribe.Information","type":"module","doc":"Add custom information for your API documentation. You must create a module to handle custom information about your API. That module must use Xcribe.Information. defmodule YourModuleInformation do use Xcribe.Information end The basic information is required and must be given inside xcribe_info block. xcribe_info do name &quot;Your awesome API&quot; description &quot;The best API in the world&quot; host &quot;http://your-api.us&quot; end"},{"ref":"Xcribe.Information.html#xcribe_info/1","title":"Xcribe.Information.xcribe_info/1","type":"macro","doc":"Defines the API custom information. This information will be used to build the final documentation. The required info are: name - a name for your API. description - a description about your API. host - your API host url Example: defmodule YourModuleInformation do use Xcribe.Information xcribe_info do name &quot;Your awesome API&quot; description &quot;The best API in the world&quot; host &quot;http://your-api.us&quot; end end"},{"ref":"Xcribe.Web.Plug.html","title":"Xcribe.Web.Plug","type":"module","doc":"Server generated API documentation. Add a doc scope to your router, and forward all requests to Xcribe.Web.Plug scope &quot;doc/swagger&quot; do forward &quot;/&quot;, Xcribe.Web.Plug end"},{"ref":"readme.html","title":"Get starting","type":"extras","doc":"Xcribe Xcribe is a doc generator for Rest APIs built with Phoenix. The documentation is generated by the test specs. Currently both Blueprint and Swagger (OpenAPI Spec 3.0) syntax are supported. In the future other formats will be added."},{"ref":"readme.html#installation","title":"Get starting - Installation","type":"extras","doc":"Add Xcribe to your application mix.exs def deps do [ {:xcribe, &quot;~&gt; 0.7.10&quot;} ] end Update deps mix deps.get Xcribe requires that you create an &quot;Information Module&quot;. This module defines the custom information about your API documentation. Create a module that uses Xcribe.Information as: defmodule YourAppWeb.Support.DocInformation do use Xcribe.Information xcribe_info do name &quot;Your awesome API&quot; description &quot;The best API in the world&quot; host &quot;http://your-api.us&quot; end end Add a new configuration with the created module config/test.exs config :xcribe, information_source: YourAppWeb.Support.DocInformation, format: :swagger, output: &quot;app_doc.json&quot; Next, in your test/test_helper.exs you should configure ExUnit to use Xcribe formatter. You would probably like to keep the default ExUnit.CLIFormatter as well. test/test_helper.exs ExUnit.start(formatters: [ExUnit.CLIFormatter, Xcribe.Formatter])"},{"ref":"readme.html#usage","title":"Get starting - Usage","type":"extras","doc":"Xcribe generates documentation from Plug.Conn struct used on your tests. To document a route you need pass the conn struct to macro document. First you need import Xcribe.Document macro in your ConnCase file (usally located in /test/support/conn_case.ex). Doing that, document/2 macro will be available into your test specs. /test/support/conn_case.ex defmodule YourAppWeb.ConnCase do use ExUnit.CaseTemplate using do quote do ... # import Xcribe `document/2` macro import Xcribe.Document ... end end end Now in your tests you should call the macro document with the conn struct test &quot;get posts&quot;, %{conn: conn} do response = conn |&gt; get(&quot;/posts&quot;) |&gt; document() |&gt; json_response(200) assert response == [] end you can specify a custom request name by passing an argument as: &quot;description&quot; to the macro test &quot;get posts&quot;, %{conn: conn} do response = conn |&gt; get(&quot;/posts&quot;) |&gt; document(as: &quot;index request&quot;) |&gt; json_response(200) assert response == [] end To generate the doc file run mix test with an env var XCRIBE_ENV=true XCRIBE_ENV=true mix test A file api_doc.apib will be created with the documentation if ApiBlueprint is configured. If Swagger format is chosen, then openapi.json file will be created. Rendering HTML The output file is write in Blueprint sintax. To render to HTML you can use the tools listed at APIBLUEPRINT.ORG If Swagger format is configured, Swagger UI can be used to display Swagger documentation."},{"ref":"readme.html#configure","title":"Get starting - Configure","type":"extras","doc":"You can add this configurations to your config/test.ex information_source: the module with doc information output: a custom name to the output file format: ApiBlueprint or Swagger formats env_var: a custom name to the env to active Xcribe.Formatter json_library: The library to be used for json decode/encode. serve: Enables Xcribe serve mode. See more in Serving doc session. Example config :xcribe, [ information_source: YourAppWeb.Information, output: &quot;API-DOCUMENTATION.apib&quot;, format: :api_blueprint # or :swagger, env_var: &quot;DOC_API&quot;, json_library: Jason ] Serve documentation Serve doc"},{"ref":"readme.html#contributing","title":"Get starting - Contributing","type":"extras","doc":"Contributing Guide"},{"ref":"readme.html#license","title":"Get starting - License","type":"extras","doc":"Apache License, Version 2.0 © brainn.co"},{"ref":"serving_doc.html","title":"Serving doc","type":"extras","doc":"Serving generated doc You can use Xcribe to serve your API documentation. Currently we support serve Swagger format. To render documentation we use Swagger UI."},{"ref":"serving_doc.html#configuration","title":"Serving doc - Configuration","type":"extras","doc":"For serving with Xcribe you must configure doc format as :swagger the output path must be priv/static and you must enable serve config. config :xcribe, information_source: YourApp.YouModuleInformation, format: :swagger, output: &quot;priv/static/my_doc.json&quot;, serve: true"},{"ref":"serving_doc.html#routing","title":"Serving doc - Routing","type":"extras","doc":"Add a doc scope to your router, and forward all requests to Xcribe.Web.Plug scope &quot;doc/swagger&quot; do forward &quot;/&quot;, Xcribe.Web.Plug end"}]